fromPosition = "";
A = new Array(); //Left tower ID a
B = new Array(); //Middle tower ID b
C = new Array(); //Right tower ID c
COMPLETE = new Array(); //Complete puzzle
completed = false;
startTime = 0;
moves = 0;
discs = 3;
finishTower="";

$(function()
{
	discs = $( "#reqdiscs" ),
	finishTower = $( "#reqfinish" );

	$( "#dialog-form" ).dialog(
	{
		autoOpen: false,
		height: 365,
		width: 375,
		modal: true,
		buttons:
		{
			"Play": function()
			{
				discs = document.getElementById("reqdiscs").value;
				finishTower = document.getElementById("reqfinish").value;
				finishTower = finishTower.toLowerCase();
//Validate number of discs
				if (isNaN(discs) == true)
				{
					document.getElementById("reqfinish").style.borderColor = "black";
					document.getElementById("errorMsg").innerHTML = "Blocks must be 3 to 10";
					document.getElementById("reqdiscs").style.borderColor = "red";					
					return false;
				}
				else
				{
					discs = parseInt(discs);	
					if (discs < 3 || discs > 10)
					{
						document.getElementById("reqfinish").style.borderColor = "black";
						document.getElementById("errorMsg").innerHTML = "Blocks must be 3 to 10";
						document.getElementById("reqdiscs").style.borderColor = "red";					
						return false;
					}
				}
//Validate Tower B or C 
				if (finishTower != 'b' && finishTower!='c'&&finishTower!='')
				{
					document.getElementById("reqdiscs").style.borderColor = "black";
					document.getElementById("errorMsg").innerHTML = "Tower must be B or C or blank";
					document.getElementById("reqfinish").style.borderColor = "red";					
					return false;
				}
//setup discs on Tower A
				for (i=discs; i>0; i--)
				{
					spritePos = 'url(images/sprite1.png) 0px -' + ((30*discs)-(i*30)) + 'px';
					document.getElementById("a" + (i-1)).style.background = spritePos;
					A[i-1] = i;
					COMPLETE[i-1] = i;
				}
//Click and pointer for ID a
				document.getElementById('a').onclick= function(){moveDisc('a');}
				document.getElementById('a').style.cursor='pointer';
				checkEmpty();
				$( this ).dialog( "close" );
			},
			"Instructions": function()
			{
				instructions();
			},
			Cancel: function()
			{
				$( this ).dialog( "close" );
			}
		},
		close: function()
		{
			$( this ).dialog( "close" );
//			allFields.val( "" ).removeClass( "ui-state-error" );
		}
	});
	$( "#dialog-form" ).dialog( "open" );

	$( ".ui-dialog" ).position(
	{
		my: "right top",
		at: "right top-35",
		of: "#a",
		collision: "none"
	});
});


function moveDisc(position)
{
	if(startTime == 0)
		start = new Date()
		startTime = start.getTime();
	if(fromPosition == "") //check for first click
	{
		fromPosition = position;
//Highlight selected disc
		if(fromPosition == 'a') //move from tower a
		{
//Calculate disc sprite position
			spritePos = ' 0px -' + ((30*discs)-(A[A.length-1]*30)) + 'px';
			fromID = fromPosition + (A.length-1);
		}
//Highlight selected
		if(fromPosition == 'b') //move from tower b
		{
//Calculate disc sprite position
			spritePos = ' 0px -' + ((30*discs)-(B[B.length-1]*30)) + 'px';
			fromID = fromPosition + (B.length-1);

		}
//Highlight selected
		if(fromPosition == 'c') //move from tower c
		{
//Calculate disc sprite position
			spritePos = ' 0px -' + ((30*discs)-(C[C.length-1]*30)) + 'px';
			fromID = fromPosition + (C.length-1);

		}
		spriteDim = 'url(images/sprite2.png)' + spritePos;
		document.getElementById(fromID).style.background = spriteDim;
		checkEmpty();
	}
	else //second tower click
	{
		if(position != fromPosition) //same tower not clicked twice 
		{
			toID="";
			if(fromPosition == 'a') //move from tower a
			{
//Calculate disc sprite position
				if(position == 'b') //move to tower b
				{	
//B is empty or last item in B is bigger than last Item in A. 
					if(B.length == 0 || B[B.length-1] < A[A.length-1])  
					{
//remove last item from array A and transfer to array B 
						B.push(A.pop());
						toID = position + (B.length-1);  
					}
				}
				else if(position == 'c') //move to c	
				{
//Check if tower c is bigger than tower a or tower c is empty. 
					if(C.length == 0 || C[C.length-1] < A[A.length-1])  
					{
//remove last item from array A and transfer to array C 
						C.push(A.pop());
						toID = position + (C.length-1);  
					}
				}

			}
			else if(fromPosition == 'b') //move from b
			{
//Calculate disc sprite position
				if(position == 'a') //move to tower a
				{
//Check if tower a is bigger than tower b or tower a is empty. 
					if(A.length == 0 || A[A.length-1] < B[B.length-1])  
					{
//remove last item from array B and transfer to array Aa 
						A.push(B.pop());
						toID = position + (A.length-1);  
					}
				}
				else if(position == 'c') //move to tower c
				{
//Check if tower c is bigger than towerrb or tower c is empty. 
					if(C.length == 0 || C[C.length-1] < B[B.length-1])  
					{
//remove last item from array B and transfer to array C 
						C.push(B.pop());
						toID = position + (C.length-1);  
					}
				}

			}
			else if(fromPosition == 'c') //move from tower c
			{
//Calculate disc sprite position
				if(position == 'a') //move to a
				{
//Check if a is bigger than c or a is empty. 
					if(A.length == 0|| A[A.length-1] < C[C.length-1])  
					{
//remove last item from c and transfer to a 
						A.push(C.pop());
						toID = position + (A.length-1);  
					}
				}
				else if(position == 'b') //move to b	
				{
//Check if b is bigger than c or b is empty. 
					if(B.length == 0 || B[B.length-1] < C[C.length-1])  
					{
//remove last item from c and transfer to b 
						B.push(C.pop());
						toID = position + (B.length-1);  
					}
				}
			}
//Move sprite to new ID  
			if(fromID != "" && toID != "")
			{
				spritePos = "url(images/sprite1.png)" + spritePos;
				document.getElementById(fromID).style.backgroundImage = "none";
				document.getElementById(toID).style.background = spritePos;
				moves++;
			}
//check for completion
			for (i=0; i<COMPLETE.length; i++)
			{
				if(finishTower == 'b')
				{
					if(COMPLETE[i] == B[i])
						complete = true;
					else
					{
						complete = false;
						break;
					}
				}
				else if(finishTower == 'c')
				{
					if(COMPLETE[i] == C[i])
						complete = true;
					else
					{
						complete = false;
						break;
					}
				}
				else
				{
					if (COMPLETE[i] == B[i] || COMPLETE[i] == C[i])
						complete = true;
					else
					{
						complete = false;
						break;
					}
				}
			}
//display Time taken, Number of moves and minnium possible moves 
			if(complete == true)
			{
				finish = new Date()
				finishTime = finish.getTime();
				elapsedTime = (finishTime - startTime)/1000;
				elapsedMins = Math.floor(elapsedTime/60).toString();
//pad leading zeros
				while(elapsedMins.length < 2)
					elapsedMins = "0" + elapsedMins;
				elapsedSecs = Math.round(elapsedTime % 60).toString();
				while(elapsedSecs.length < 2)
					elapsedSecs = "0" + elapsedSecs;
//Set parameters for play again dialig
				document.getElementById("results").innerHTML = "YOUR TIME " + elapsedMins + ":" + elapsedSecs + "<br />" + moves + " MOVES<br />Minimum possible moves: " + (Math.pow(2,discs)-1) + "<br /><br /><b>Play again ?</b>"
//Play Again dialog box
				$(function()
				{
					$( "#dialog-confirm" ).dialog(
					{
						resizable: false,
						width:290,
						height:300,
						modal: true,
						buttons:
						{
							"Yes": function()
							{
								window.location = 'index.html';
							},
							"No": function()
							{
								$( this ).dialog( "close" );
		
							}
						}
					});
				});
//Position dialog box  
				$( ".ui-dialog" ).position(
				{
					my: "center top",
					at: "center top",
					of: "#a",
					collision: "none"
				});
			}
		}
		spritePos = 'url(images/sprite1.png)' + spritePos;
		document.getElementById(fromID).style.background = spritePos;
		fromPosition = "";
		checkEmpty();
	}
}

//changes the click status of each tower  
function checkEmpty()
{
//from - change cursors & disallow clicking on towers WITHOUT discs  
	if(fromPosition == "")
	{
		if(A.length < 1)
		{
			document.getElementById('a').onclick = function(){moveDisc('');}
			document.getElementById('a').style.cursor='default';
		}
		if(B.length < 1)
		{
			document.getElementById('b').onclick = function(){moveDisc('');}
			document.getElementById('b').style.cursor='default';
		}
		if(C.length < 1)
		{
			document.getElementById('c').onclick = function(){moveDisc('');}
			document.getElementById('c').style.cursor = 'default';
		}
	}
//to - change cursors & allow clicking on ALL towers
	else
	{
		document.getElementById('a').onclick = function(){moveDisc('a');}
		document.getElementById('a').style.cursor = "pointer";
		document.getElementById('b').onclick = function(){moveDisc('b');}
		document.getElementById('b').style.cursor = "pointer";
		document.getElementById('c').onclick = function(){moveDisc('c');}
		document.getElementById('c').style.cursor = "pointer";
	}
}

function instructions()
{
	$(function() {
		$( "#dialog" ).dialog({
			autoOpen: true,
			height: 250,
			width: 580,
			modal: true,
			show: {
				effect: "blind",
				duration: 1000
			},
			hide: {
				effect: "blind",
				duration: 1000
			}
		});
	});
}
